// Bruch.java                                       MM 2014

/**
 * Gemeine Brueche.
 * @author Monika Meiler
 */
public class Bruch
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Zaehler.
 */
  private int zaehler = 0;

/**
 * Nenner.
 */
  private int nenner = 1;

/* ----------------------------------------------------- */
                                             // set-Methode
/**
 * Setzt Zaehler und Nenner eines Bruchs.
 * @param z Zaehler
 * @param n Nenner
 * @return false, falls Nenner == 0, sonst true
 */
  public boolean setBruch( int z, int n)
  {
    if( n == 0) return false;

//    if( z == 0) n = 1;
    zaehler = z;
    nenner = n;
    kuerzen();

    return true;
  }

/**
 * Kuerzen eines Bruchs mit Euklid.
 */
  private void kuerzen()
  {
    int m = Math.abs( zaehler);
    int n = Math.abs( nenner);

    int r;
    do
    {
      r = m % n;
      m = n;
      n = r;
    } while( n != 0);

    if( m > 1)
    {
      zaehler /=  m;
      nenner /= m;
    }
  }

/* ----------------------------------------------------- */
                                            // get-Methoden
/**
 * Lesen des Zaehlers.
 */
  public int getZaehler()
  {
    return zaehler;
  }

/**
 * Lesen des Nenners.
 */
  public int getNenner()
  {
    return nenner;
  }

/* ----------------------------------------------------- */
                                             // Operationen
/**
 * Addition.
 * @param a Bruch, zweiter Operand
 * @return Summe der Brueche
 */
  public Bruch add( Bruch a)
  {
    int x = zaehler  * a.getNenner()
          + nenner * a.getZaehler();
    int y = nenner * a.getNenner();

    Bruch b = new Bruch();
    b.setBruch( x, y);
    return b;
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellung eines Bruchs.
 */
  public String toString()
  {
     return "" + zaehler + " / " + nenner;
  }

/* ----------------------------------------------------- */
/* ----------------------------------------------------- */
/**
 * Testprogramm zur Klasse Bruch,
 * 1: 2 / 3 + 3 / 18 = 2 / 3 + 1 / 6 = 5 / 6,
 * 2: 2 * 5 / 6 = 5 / 6 + 5 / 6 = 10 / 6 = 5 / 3.
 */
  public static void main( String[] args)
  {
    Bruch a = new Bruch();
    a.setBruch( 2, 3);
    Bruch b = new Bruch();
    b.setBruch( 3, 18);

    Bruch c = new Bruch();
    c = a.add( b);
    System.out.println( a + " + " + b + " = " + c);

    Bruch d = new Bruch();
    d = c.add( c);
    System.out.println( "2 * " + c + " = " + d);
  }
}
