// EuroDollar.java                                  MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Umrechnungsprogramm Euro <-> Dollar
 * entsprechend des Tageskurses.
 * @author Monika Meiler
 */
public class EuroDollar
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Tageskurs Dollar -> Euro.
 */
  private double dollarKurs = 1;

/**
 * Tageskurs Euro -> Dollar.
 */
  private double euroKurs = 1;

/* ----------------------------------------------------- */
                                             // set-Methode
/**
 * Setzt Euro- und Dollarkurs.
 * @param kurs aktueller Kurs (!=0)
 * @param dollar true, falls kurs Dollarkurs
 * @return true, falls Werte korrekt
 */
  public boolean setKurs( double kurs, boolean dollar)
  {
    if( kurs == 0) return false;

    if( dollar)
    {
      dollarKurs = kurs;
      euroKurs = 1 / kurs;
    }
    else
    {
      euroKurs = kurs;
      dollarKurs = 1 / kurs;
    }
    return true;
  }

/* ----------------------------------------------------- */
                                             // get-Methode
/**
 * Gibt gerade aktuellen Tageskurs an.
 */
  public String getKurse()
  {
    String str = "Umrechnungskurse\n";
    str += "  Dollar -> Euro: " + dollarKurs + "\n";
    str += "  Euro -> Dollar: " + euroKurs;
    return str;
  }

/* ----------------------------------------------------- */
                                        // service-Methoden
/**
 * Umrechnung Dollar <-> Euro,
 * gerundet auf 2 Stellen nach dem Komma.
 * @param geld Geldwert
 * @param dollar true, falls in Dollar
 * @return umgerechneter Geldwert
 */
  public double dollarToEuro
  ( double geld, boolean dollar)
  {
    double kurs = dollarKurs;                       // Kurs
    if( dollar) kurs = euroKurs;

    double wert = geld * kurs;                 // Berechnen
    wert = Math.rint( wert * 100) / 100;          // Runden
    return wert;
  }

/* ----------------------------------------------------- */
                                                  // Dialog
/**
 * Dialog zwischen Nutzer und Programm.
 */
  public void dialog()
  {
// Ueberschrift
    System.out.println( "Umrechnung Euro <-> Dollar");

// Eingabe Kurs
    System.out.println( "  Dollarkurs     ... 1");
    System.out.print  ( "  Eurokurs       ... 2");
    int eingabe = IOTools.readInteger( ": ");

      double kurs;
      switch( eingabe)
      {
        case 1:                       // Eingabe Dollarkurs
          kurs = IOTools.readDouble( "Dollarkurs: ");
          setKurs( kurs, true);
          break;

        case 2:                         // Eingabe Eurokurs
          kurs = IOTools.readDouble( "Eurokurs: ");
          setKurs( kurs, false);
          break;
      }
      System.out.println( getKurse());

    char weiter = 'j';
    do
    {
// Menue
      System.out.println( "Eingabemenue");
      System.out.println( "  Dollarkurs neu  ... 1");
      System.out.println( "  Eurokurs neu    ... 2");
      System.out.println( "  Dollar -> Euro  ... 3");
      System.out.print  ( "  Euro -> Dollar  ... 4");

      eingabe = IOTools.readInteger( ": ");

      double wert;
// Auswahl
      switch( eingabe)
      {
        case 1:                       // Eingabe Dollarkurs
          kurs = IOTools.readDouble( "Dollarkurs: ");
          setKurs( kurs, true);
          System.out.println( getKurse());
          break;

        case 2:                         // Eingabe Eurokurs
          kurs = IOTools.readDouble( "Eurokurs: ");
          setKurs( kurs, false);
          System.out.println( getKurse());
          break;

        case 3:                // Berechnung Dollar -> Euro
            wert = IOTools.readDouble( "Dollar: ");
            System.out.println
            ( "Euro  : " + dollarToEuro( wert, true));
          break;

        case 4:                // Berechnung Euro -> Dollar
            wert = IOTools.readDouble( "Euro  : ");
            System.out.println
            ( "Dollar: " + dollarToEuro( wert, false));
      }

// Weiter
      weiter = IOTools.readChar( "Weiter (j/n)? ");
    } while( weiter == 'j');

// Fertig
    System.out.println( "Programm beendet");
  }

/* ----------------------------------------------------- */

/**
 * Startet das Programm.
 */
  public static void main( String[] args)
  {
// Objekt erzeugen
    EuroDollar umrechner = new EuroDollar();

// Dialog starten
    umrechner.dialog();
  }
}

/* ------------------------------------------------- */
/* Tageskurse:
   http://www.finanzen.net/devisen/dollarkurs
*/
