// QuadGleichung.java                              MM 2013
import Tools.IO.*;                             // Eingaben

/**
 * Loesen einer quadratische Gleichung
 * in der Form f(x) = x^2 + px + q = 0.
 * @author Monika Meiler
 */
public class QuadGleichung
{
/**
 * Eingabe von p und q, Ausgabe der Gleichung,
 * Berechnen und Ausgabe der Loesungen.
 */
  public static void main( String[] args)
  {
    // Einlesen der Parameter p und q
    System.out.println( "f(x) = x^2 + px + q = 0");
    double p = IOTools.readDouble("p = ");
    double q = IOTools.readDouble("q = ");

    // Ausgabe der Gleichung
    System.out.println
    ( "f(x) = x^2 + " + p + "x + " + q + " = 0");

    // Berechnen der Diskriminante d
    double h = - p / 2;
    double d = h * h - q;

    // Fallunterscheidung
    if( d > 0 )                             // 2 Loesungen
    {
      d = Math.sqrt( d);
      System.out.println
      ( "x1 = " + ( h + d) + ", x2 = " + (h - d));
    }
    else if( d == 0)                       // eine Loesung
      System.out.println( "x = " + h);
    else                                  // keine Loesung
      System.out.println( "Keine reellen Loesungen!");
  }
}

/* ---------------------------------------------------- */
/* Testbeispiel f(x) = x^2 + -3.0x + 3.0 = 0
   Keine reellen Loesungen!

   Testbeispiel f(x) = x^2 + -10.0x + 25.0 = 0
   x = 5.0

   Testbeispiel f(x) = 9x^2 - 1 = 0
   x1 = 0.3333333333333333, x2 = -0.3333333333333333
*/

